{ file CmStatus.pas, created on 7/11/2000 by Cyrille de Brbisson

 This thing is a status dialog box.
 It is used to display something while the download takes place in an other thread.
 see XModemServer.PutFile for example

 Copyright (c) Hewlett-Packard Australia Ltd. 2000
 All rights reserved.  Reproduction, adaptation or translation
 without prior written permission is prohibited, except as
 allowed under the copyright laws.}

 //  Changes marked with WGG are copyright 2002, William G. Graves

unit CmStatus;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TFCmStatus = class(TForm)
    ProgressBar2: TProgressBar;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    function Execute(Text: string; showCancel: boolean = true): integer;
    Procedure Action(m: string; o, v1, v2, v3: integer);
    procedure CenterOnMe(Sender: TForm);   // wgg form to use for centering
  end;

var
  FCmStatus: TFCmStatus;
  HPDirForm: TForm;

implementation

uses LogIt, YModem;
{$R *.DFM}

{ TFStatus }

procedure TFCmStatus.CenterOnMe(Sender: TForm);   // form to use for centering
begin
  HPDirForm:= Sender;    // remember so we can center and then restore
end;

procedure TFCmStatus.Action(m: string; o, v1, v2, v3: integer);
begin
  FLog.Memo1.Lines.Add(M);
  if not visible then exit;
  if o = opEnd then begin close; ModalResult:= mrOk; exit; end;
  Label1.Caption := m;
  if o = opPercent then
  begin
    ProgressBar2.Max:= v2;
    ProgressBar2.Position:= v1;
  end;
  if o = opCancelState then BitBtn1.Enabled:= m='1';
end;

Function TFCmStatus.Execute(Text: string; showCancel: boolean = true): integer;
begin
  Caption:= Text;
  Label1.Caption:= '';
  ProgressBar2.Max := 1;
  ProgressBar2.Position:= 0;
  BitBtn1.Visible:= ShowCancel;
  BitBtn1.Enabled:= true;
  result:= ShowModal;
end;

procedure TFCmStatus.Timer1Timer(Sender: TObject);
begin
 Invalidate;
end;

procedure TFCmStatus.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not BitBtn1.Enabled then
    Action:= caNone;
end;

procedure TFCmStatus.FormShow(Sender: TObject);
begin
  if HPDirForm=Nil then exit;
  Left:= (HPDirForm.Width-Width) div 2 + HPDirForm.Left;
  Top:= (HPDirForm.Height-Height) div 2 + HPDirForm.Top;
end;

end.
