{ file HPDir.pas, created on 7/11/2000 by Cyrille de Brbisson

 This is the HPDir UI, it contains the drag/drop logic and interact with the XModemServer
 defined in YModem.pas

 Copyright (c) Hewlett-Packard Australia Ltd. 2000
 All rights reserved.  Reproduction, adaptation or translation
 without prior written permission is prohibited, except as
 allowed under the copyright laws.}

// Items marked wgg are copyright 2002, William G. Graves

unit HPDir;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls,
  Menus, windowsPosSave, ImgList, utils,
  DropTarget, DropSource, ToolWin, ExtCtrls, ComCtrls, graphics, Messages,
  ScktComp, Dialogs, shellapi, YModem;

type
  TProjectCallBack = procedure(server: TXModemServer) of object;
  TProjectCallBack2 = function: TFileName of object;

type
  TFHPDir = class(TForm)
    ListView1: TListView;
    MainMenu1: TMainMenu;
    Files1: TMenuItem;
    Delete1: TMenuItem;
    Property1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    Edit1: TMenuItem;
    SelectAll1: TMenuItem;
    InvertSelection1: TMenuItem;
    View1: TMenuItem;
    Toolbar1: TMenuItem;
    StatusBar1: TMenuItem;
    N4: TMenuItem;
    LargeIcons1: TMenuItem;
    SmallIcons1: TMenuItem;
    List1: TMenuItem;
    Details1: TMenuItem;
    N5: TMenuItem;
    Refresh1: TMenuItem;
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    StatusBar2: TStatusBar;
    ToolBar2: TToolBar;
    ComboBox1: TComboBox;
    WindowPosSave1: TWindowPosSave;
    ImageList1: TImageList;
    Copy1: TMenuItem;
    Pastel1: TMenuItem;
    N2: TMenuItem;
    btnLog: TButton;
    Label1: TLabel;
    ToolButton1: TToolButton;
    PopupMenu1: TPopupMenu;
    Delete2: TMenuItem;
    Property2: TMenuItem;
    N3: TMenuItem;
    Copy2: TMenuItem;
    Pastel2: TMenuItem;
    N6: TMenuItem;
    Refresh2: TMenuItem;
    ToolButton4: TToolButton;
    OpenDialog1: TOpenDialog;
    mnuConnect: TMenuItem;
    DropFileTarget1: TDropFileTarget;
    DropFileTarget2: TDropFileTarget;
    DropFileSource1: TDropFileSource;
    Help1: TMenuItem;
    N7: TMenuItem;
    ToolButton7: TToolButton;
    Timer1: TTimer;
    Panel1: TPanel;
    mnuRename1: TMenuItem;
    N8: TMenuItem;
    mnuRename2: TMenuItem;
    N9: TMenuItem;
    mnuDownLoadServer: TMenuItem;
    mnuContentsHelp: TMenuItem;
    mnuCommHelp: TMenuItem;
    mnuAbout: TMenuItem;
    mnuPutProject: TMenuItem;
    mnuDownLoadFile: TMenuItem;
    mnuCaptureScreen: TMenuItem;
    SaveDialog1: TSaveDialog;
    mnuUploadFile: TMenuItem;
    mnuDownLoadProject: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ListView1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ListView1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Close1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure ComboBox1Change(Sender: TObject);
    procedure ListView1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure DropFileSource1Drop(Sender: TObject; DragType: TDragType; var ContinueDrop: Boolean);
    procedure DropFileTarget1Drop(Sender: TObject; ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
    procedure Delete1Click(Sender: TObject);
    procedure Property1Click(Sender: TObject);
    procedure View1Click(Sender: TObject);
    procedure Toolbar1Click(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
    procedure LargeIcons1Click(Sender: TObject);
    procedure SmallIcons1Click(Sender: TObject);
    procedure List1Click(Sender: TObject);
    procedure Details1Click(Sender: TObject);
    procedure Timer1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure InvertSelection1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Pastel1Click(Sender: TObject);
    procedure btnLogClick(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Files1Click(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DropFileTarget2Drop(Sender: TObject; ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
    procedure ToolButton6Click(Sender: TObject);
    procedure ListView1Edited(Sender: TObject; Item: TListItem; var S: String);
    procedure ListView1DblClick(Sender: TObject);
    procedure mnuContentsHelpClick(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure mnuDownLoadServerClick(Sender: TObject);
    procedure mnuCaptureScreenClick(Sender: TObject);
    procedure mnuDownLoadFileClick(Sender: TObject);
    procedure mnuCommHelpClick(Sender: TObject);
    procedure mnuPutProjectClick(Sender: TObject);
    procedure mnuUploadFileClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mnuDownLoadProjectClick(Sender: TObject);
  private
    Fconnected: boolean;
    DragPoint: TPoint;
    CPoint: TPoint;
    AlreadyDragging: boolean;
    XModemServer: TXModemServer;
    currentDir: TFileName;
    FCalcTypeString: string;                   // wgg received as part of version string from calc
    FCalcVersion: string;                      // wgg ROM version id
    Procedure Refresh;
    Function GetCalcTypeString: string;
    Procedure Status(sender: TObject; Messages: string; operation, v1, v2, v3: integer);
    Procedure DeleteFiles;
    Procedure SetDisabled;
    procedure SetCalcTypeString(s: string);                                   // wgg
    procedure ShowBusy(state: boolean);                                       // wgg
    procedure SetComPort;                                                     // wgg
  public
    procedure ShowConnected;                                                      // wgg
    procedure Setconnected(const Value: boolean);                                 // wgg made public
    property CalcTypeString: string read FCalcTypeString write SetCalcTypeString; // wgg
    property CalcVersion: string read FCalcVersion write FCalcVersion;            // wgg
    property connected: boolean read Fconnected write Setconnected;               // wgg made public
    function IsCalc49: boolean;                                                   // wgg
    property server: TXModemServer read XModemServer;                             // wgg
    function ApplicationOnHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean; // wgg
    procedure TopicHelp(topic: string);                                           // wgg
    procedure ContextHelp(id: integer);                                           // wgg
    procedure DoDownloadFile(f: TFileName; prompt: integer);                      // wgg
    procedure SetLoadToReal(p: TProjectCallBack);                                 // wgg
    procedure SetProjectFile(p: TProjectCallBack2);                               // wgg
end;

const
  HP49String: string = '49';                                                      // wgg
  PopupFileName = 'cshelp.txt';                                                   // wgg also in mainform

var
  FHPDir: TFHPDir;
  InitializeCom: boolean;                                         // wgg true=ingnore comm changes
  cmRegKey: string;                                               // used for registry settings
  CmRegSubKey: string;
  FLoadToReal: TProjectCallBack;              // wgg this way we dont "use FProject"
  FProjectFile: TProjectCallBack2;            // wgg this way we dont "use FProject"

implementation

uses
  Properties, LogIt, CmStatus, FixObj, ScreenCapt, DownLd,
  Registry, RegistryValues, HtmlHlp, About;   // wgg removed  Mandel, MandelF

{$R *.DFM}
procedure TFHPDir.FormCreate(Sender: TObject);
var
  o: TXPObject;
  L: TStringList;
begin
  Caption:= 'HP Xmodem Connectivity Kit';
  if Application.Mainform = Nil then           // wgg we are still creating mainform
    Caption:= 'Conn4x, '+Caption;
  btnLog.visible:= debug;
  FLog:= TLogForm.Create(self);
  FCmStatus:= TFCmStatus.Create(self);
  XModemServer:= TXModemServer.Create;
  XModemServer.StatusReport:= Status;
  WindowPosSave1.ReadPos;
  o:= TXPObject.create;
  with TreeView1.Items.Add(nil, 'HP ?') do
  begin
    Data:= o;
    ImageIndex:= 0;
    SelectedIndex:= 11;
  end;
  o.parent:= nil;
  o.Caption:= '\';
  o.size:= 0;
  o.ImageIndex:= 0;
  o.XModemServer:= XModemServer;
  SetDelimiter(#10);
  DropFileTarget1.Register(ListView1);
//  DropFileTarget2.Register(TreeView1);
  L:= TStringList.Create;
  L.text:= ListComm;
  L.Sorted:= true;
  ComboBox1.Items.text:= 'Auto'#10+L.Text;         // wgg removed +disconnect;
  L.free;

  // wgg load registry settings
  InitializeCom:= true;
  if Application.MainForm = Nil then     // wgg we are still creating mainform
  begin
    cmRegKey:= RegistryKeyComm;
    cmRegSubKey:= '';
  end else begin
    cmRegKey:= RegistryKey;
    cmRegSubKey:= 'Connectivity';
  end;
  with TRegIniFile.Create(cmRegKey) do
    try
      ComboBox1.ItemIndex:= ComboBox1.Items.Indexof(ReadString(cmRegSubKey, 'Port', 'Auto'));  // wgg
      XModemServer.Speed:= ReadString(cmRegSubKey, 'Speed', '9600'); // wgg
    finally
      free;
      InitializeCom:= false;
    end;

  // if not debug then SetComPort;  // wgg auto start can take too long if no connection
  SetDisabled;
end;

// wgg general purpose show connection state routine
procedure TFHPDir.ShowBusy(state: boolean);                                       // wgg
begin
  if state then Screen.Cursor:= crHourGlass
  else Screen.Cursor:= crDefault;
  Application.ProcessMessages;
end;

// set private x,y variables to detect start of drag (FROM) operation
procedure TFHPDir.ListView1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if mbLeft = Button then
  begin
    DragPoint:= Point(x,y)
  end else
    DragPoint:= Point(-1,-1);
  CPoint:= DragPoint;
end;

procedure TFHPDir.ListView1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if mbLeft = Button then
  begin
    DragPoint:= Point(-1,-1);
  end;
end;

procedure TFHPDir.ListView1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  i: integer;
begin
  if AlreadyDragging then exit;
  //Filter out all but the mouse buttons from 'Shift'...
  Shift:= (Shift * [ssLeft,ssRight]);
  //Make sure a mouse button is pressed before starting the drag ...
  //and the mouse has moved at least 10 pixels
  //(DragPoint is set in the ListView1MouseDown event)
  //If no files selected then exit...
  if  (Shift = []) or
      ((abs(DragPoint.X - X) <10) and (abs(DragPoint.Y - Y) <10)) or
      (Listview1.SelCount = 0) then exit;
  //Delete any filenames left from a previous dragdrop...
  DropFileSource1.Files.clear;
  //Fill DropSource1.Files with selected filenames in ListView1...
  for i:= 1 to ListView1.items.count do
    if ListView1.items[i-1].selected then
      DropFileSource1.Files.Objects[DropFileSource1.Files.add(
        GetTempDir+'\'+ListView1.items[i-1].caption)]:=
          Pointer(StrToInt(ListView1.items[i-1].SubItems[0]));
  //Stop this event being re-executed once a drag has been initiated...
  AlreadyDragging := true;
  //Start the dragdrop...
  //Note: DropFileSource1.DragTypes = [dtCopy] set at design time.
  DropFileTarget1.Unregister;
  try
    DropFileSource1.execute;
  finally
    //Note: Execute does not return until the drop has finished
    //either sucessfully with a copy,move of link operation or cancelled.
    DropFileTarget1.register(ListView1);
    AlreadyDragging := false;
  end;
end;

procedure TFHPDir.Close1Click(Sender: TObject);
begin
  Close;
end;
 
procedure TFHPDir.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FHPDir.connected=true then XModemServer.Kill;          // wgg kill the calc server
  XModemServer.com:= '';
  with TRegIniFile.Create(cmRegKey) do
  try
    WriteString(cmRegSubKey, 'Port',  ComboBox1.Text);  // wgg
    WriteString(cmRegSubKey, 'Speed', XModemServer.Speed); // wgg
  finally
    free;
  end;
  if Application.MainForm = self then
  begin
    WindowPosSave1.SavePos;      // wgg not in integrated system
    DropFileTarget1.Unregister;
    DropFileTarget2.Unregister;
    TerminateProcess(GetCurrentProcess, 0); // and kill everything killing badly allow to avoid unexpected crashes :-(
  end;
end;

procedure TFHPDir.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  j, i: integer;
begin
  ShowBusy(True);                 // wgg
  Application.ProcessMessages;
  try
    ListView1.Items.clear;
    if Node<>nil then
      with TObject(Node.Data) as TXPObject do
      begin
        currentDir:= GetfullPathName;
        for i:=0 to high(Items) do
        begin
          if Items[i].IsDirectory then
          begin
            j:=0;
            while (j<Node.Count) and (Node.Item[j].text<>Items[i].Caption) do inc(j);
            if j=Node.Count then
              with TreeView1.items.addChild(Node, Items[i].Caption) do
              begin
                Data:= Items[i];
                ImageIndex:= 0;
                SelectedIndex:= 11;
              end;
          end;
          with ListView1.Items.Add do // wgg removed if Items[i].IsDirectory then
          begin
            Caption:= Items[i].Caption;
            Selected:= false;
            Checked:= false;
            Cut:= false;
            Focused:= false;
            ImageIndex:= Items[i].ImageIndex;
            SubItems.add(inttostr(Items[i].Size));
          end;
        end;
      end;
  finally
    ShowBusy(false);     // wgg
  end;
end;

procedure TFHPDir.ComboBox1Change(Sender: TObject);
begin
  if InitializeCom then exit;                         // wgg skip during startup
  // wgg nothing left to do after SetComPort removed !
end;

// wgg I broke this off from ComboBox1Change so starting is independent of setting
procedure TFHPDir.SetComPort;
begin
  while timer1.Enabled do Application.ProcessMessages;
  ShowBusy(true);   // wgg
  try
    if ComboBox1.Text <> Disconnect then
      try
        connected:= false;         // wgg was before first try
        XModemServer.com:= ComboBox1.Text;
        (TObject(TreeView1.Items[0].Data) as TXPObject).freeSubObjects;
        TreeView1.Items[0].DeleteChildren;
      finally
        Connected:= XModemServer.connected;
        if connected then Refresh;              // wgg
      end
    else
    begin
      XModemServer.Kill;                       // wgg kill the calc server
 //     XModemServer.com:= Disconnect;
    end;
  finally
  ShowBusy(false);   // wgg
  end;
end;

procedure TFHPDir.Status(sender: TObject; Messages: string; operation, v1, v2, v3: integer);
begin
  StatusBar2.Panels[0].text:= Messages;
  if debug then
    FLog.Memo1.Lines.add(Messages);
  Application.ProcessMessages;
end;

procedure TFHPDir.DropFileSource1Drop(Sender: TObject; DragType: TDragType; var ContinueDrop: Boolean);
var
  i: integer;
  FileName: TFileName;
  fileSize: integer;
begin
  // If files are to be extracted from an archive or downloaded
  // from the net do it here - into the Temp Directory - and
  // then move them from there to the Target Directory.
  ShowBusy(true);   // wgg
  try
    // download the file in the temp directory
    XModemServer.changeDirectory(CurrentDir);
    for i:=0 to DropFileSource1.Files.count-1 do
    Begin
      FileName:= DropFileSource1.Files[i];
      FileSize:= Integer(DropFileSource1.Files.objects[i]);
      if not XModemServer.Get(ExtractFileName(FileName), FileName, FileSize) then exit;
    end;
  finally
  ShowBusy(false);   // wgg
  end;
end;

procedure TFHPDir.Delete1Click(Sender: TObject);
begin
  DeleteFiles;
end;

procedure TFHPDir.Rename1Click(Sender: TObject);
begin
  ListView1.Selected.EditCaption;                // wgg
end;

procedure TFHPDir.DeleteFiles;
var
  i: integer;
begin
  ShowBusy(true);   // wgg
  try
    if not ListView1.Enabled then exit;
    XModemServer.changeDirectory(currentDir);
    for i := 1 to ListView1.items.count do
      if ListView1.items[i-1].selected then
        XModemServer.PurgeFile(ListView1.items[i-1].Caption);
  finally
  ShowBusy(false);   // wgg
  end;
  Timer1.Enabled:= true;
end;

procedure TFHPDir.Property1Click(Sender: TObject);
var
  i: integer;
  size: integer;
  time: integer;
  s: string;
begin
  if ListView1.SelCount = 0 then exit;
  s:= '';
  size:= 0;
  for i := 1 to ListView1.items.count do
    if ListView1.items[i-1].selected then
    begin
      s:= s+ListView1.items[i-1].Caption+#10;
      Size:= Size+strtoint(ListView1.items[i-1].SubItems[0]);
    end;
  time:= size div (strtoint(XModemServer.Speed) div 10);
  FProperty.execute(s, Size, Time);
end;

procedure TFHPDir.View1Click(Sender: TObject);
begin
  Toolbar1.Checked:= Toolbar2.Visible;
  StatusBar1.Checked:= StatusBar2.visible;
  LargeIcons1.Checked:= false;
  SmallIcons1.Checked:= false;
  List1.Checked:= false;
  Details1.Checked:= false;
  case ListView1.ViewStyle of
    vsIcon: LargeIcons1.Checked:= true;
    vsSmallIcon: SmallIcons1.Checked:= true;
    vsList: List1.Checked:= true;
    vsReport: Details1.Checked:= true;
  end;
end;

procedure TFHPDir.Toolbar1Click(Sender: TObject);
begin
  Toolbar2.Visible:= not Toolbar2.Visible;
end;

procedure TFHPDir.StatusBar1Click(Sender: TObject);
begin
  StatusBar2.Visible:= not StatusBar2.Visible;
end;

procedure TFHPDir.LargeIcons1Click(Sender: TObject);
begin
  ListView1.ViewStyle:= vsIcon;
end;

procedure TFHPDir.SmallIcons1Click(Sender: TObject);
begin
  ListView1.ViewStyle:= vsSmallIcon;
end;

procedure TFHPDir.List1Click(Sender: TObject);
begin
  ListView1.ViewStyle:= vsList;
end;

procedure TFHPDir.Details1Click(Sender: TObject);
begin
  ListView1.ViewStyle:= vsReport;
end;

procedure TFHPDir.Timer1Click(Sender: TObject);
begin
  Refresh;
end;

procedure TFHPDir.SelectAll1Click(Sender: TObject);
var
  i: integer;
begin
  for i := 1 to ListView1.items.count do
    ListView1.items[i-1].selected:= true;
end;

procedure TFHPDir.InvertSelection1Click(Sender: TObject);
var
  i: integer;
begin
  for i := 1 to ListView1.items.count do
    ListView1.items[i-1].selected:= not ListView1.items[i-1].selected;
end;

procedure TFHPDir.mnuAboutClick(Sender: TObject);
begin
  with TURLForm.Create(self) do
  begin
    calctype:= GetCalcTypeString;
    ShowModal;
    free;
  end;
end;

// wgg reinstate/display current status
procedure TFHPDir.ShowConnected;
begin
  SetConnected(XModemServer.Connected);
end;

procedure TFHPDir.Setconnected(const Value: boolean);
begin
  if Fconnected <> Value then Fconnected:= Value;
  SetDisabled;
end;

procedure TFHPDir.SetDisabled;
begin
  ListView1.Enabled:= connected;
  TreeView1.Enabled:= connected;
  Delete1.Enabled:= connected;
  mnuRename2.Enabled:= connected;
  Refresh1.Enabled:= connected;
  Pastel1.Enabled:= connected;
  Copy1.Enabled:= connected;
  if connected then
  begin
    ToolButton4.ImageIndex:= 8;
    ToolButton4.Hint:= 'Disconnect';
  end else begin
    ToolButton4.ImageIndex:= 12;
    ToolButton4.Hint:= 'Connect';
    ShowBusy(false);
  end;
end;

procedure TFHPDir.Copy1Click(Sender: TObject);
var
  i: integer;
  FileName: TFileName;
  fileSize: integer;
begin
  ShowBusy(true);   // wgg
  try
    DropFileSource1.Files.clear;
    //Fill DropSource1.Files with selected filenames in ListView1...
    for i := 1 to ListView1.items.count do
      if ListView1.items[i-1].selected then
        DropFileSource1.Files.Objects[DropFileSource1.Files.add(GetTempDir+'\'+ListView1.items[i-1].caption)]:=
          Pointer(StrToInt(ListView1.items[i-1].SubItems[0]));
    // If files are to be extracted from an archive or downloaded
    // from the net do it here - into the Temp Directory - and
    // then move them from there to the Target Directory.
    // download the file in the temp directory
    XModemServer.changeDirectory(CurrentDir);
    for i:=0 to DropFileSource1.Files.count-1 do
    Begin
      FileName:= DropFileSource1.Files[i];
      FileSize:= Integer(DropFileSource1.Files.objects[i]);
      if not XModemServer.Get(ExtractFileName(FileName), FileName, FileSize) then exit;
    end;
    DropFileSource1.CopyToClipboard;
  finally
  ShowBusy(false);   // wgg
  end;
end;

procedure TFHPDir.Pastel1Click(Sender: TObject);
var
  i: integer;
begin
  ShowBusy(true);   // wgg
  try
    if not ListView1.Enabled then exit;
    DropFileTarget1.PasteFromClipboard;
    XModemServer.changeDirectory(currentDir);
    with DropFileTarget1 do
      for i := 0 to files.count-1 do
        if not XModemServer.put(ExtractFileName(Files[i]), Files[i]) then exit;
  finally
  ShowBusy(false);   // wgg
  end;
  Timer1.Enabled:= true;
end;

procedure TFHPDir.btnLogClick(Sender: TObject);
begin
  FLog.show;
end;

procedure TFHPDir.Refresh;
var
  t: TTreeNode;
begin
  ShowBusy(true);  // wgg
  try
    Timer1.Enabled:= false;
    TreeView1.SetFocus;
    t:= TreeView1.Selected;
    if t<>nil then
    begin
      (TObject(t.Data) as TXPObject).freeSubObjects;
      t.DeleteChildren;
    end;
    TreeView1.Selected:= nil;
    TreeView1.Selected:= t;
    TreeView1Change(TreeView1,t);
    StatusBar2.Panels[0].text:= XModemServer.Version;
    StatusBar2.Panels[1].text:= 'Free Mem: '+XModemServer.GetMemory;
  finally
    ShowBusy(false);   // wgg
  end;
end;

procedure TFHPDir.ToolButton4Click(Sender: TObject);
begin
  if Not Connected then SetComPort
  else
  begin
    XModemServer.Kill;                       // wgg kill the calc server
  //  XModemServer.com:= Disconnect;
  end;
end;

procedure TFHPDir.PopupMenu1Popup(Sender: TObject);
begin
  Copy1.Enabled:=  ListView1.SelCount<>0;
  Copy2.Enabled:=  ListView1.SelCount<>0;
  Delete1.Enabled:=  ListView1.SelCount<>0;
  Delete2.Enabled:=  ListView1.SelCount<>0;
  mnuRename1.Enabled:=  ListView1.SelCount<>0;
  mnuRename2.Enabled:=  ListView1.SelCount<>0;
  Property1.Enabled:=  ListView1.SelCount<>0;
  Property2.Enabled:=  ListView1.SelCount<>0;
  Pastel1.Enabled:= DropFileTarget1.files.count<>0;
  Pastel2.Enabled:= DropFileTarget1.files.count<>0;
  DropFileTarget1.PasteFromClipboard;
end;

// wgg we are doing all this so HPDir code can be somewhat decoupled from Debug4x
// and we can use the same source file for both Conn4x and Debug4x
procedure TFHPDir.SetLoadToReal(p: TProjectCallBack);                         // wgg
begin
  FLoadToReal:= p;
end;

procedure TFHPDir.SetProjectFile(p: TProjectCallBack2);                         // wgg
begin
   FProjectFile:= p;
end;

procedure TFHPDir.Files1Click(Sender: TObject);
begin
  Property1.Enabled:=  ListView1.SelCount<>0;
  if connected then mnuConnect.Caption:= 'Disconnect'
  else mnuConnect.Caption:= 'Connect';
  mnuPutProject.Visible:= (@FLoadToReal<>Nil);
  mnuDownLoadProject.Visible:= (@FProjectFile<>Nil);

  mnuPutProject.Enabled:= Connected;
  mnuDownLoadProject.Enabled:= Not Connected;
  mnuDownLoadServer.Enabled:= Not Connected;
  mnuDownloadFile.Enabled:= Not Connected;
  mnuUploadFile.Enabled:= Not Connected;
  mnuCaptureScreen.Enabled:= Not Connected;
end;

procedure TFHPDir.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//  caption:= inttostr(key);
  if not ListView1.IsEditing then
    if Key = 46 then
      DeleteFiles;
 { if (Key = ord('M')) and (ssCtrl in Shift) then
    FMandel.ShowModal;  }
  if (Key = ord('K')) and (ssCtrl in Shift) then
    XModemServer.Kill;
end;

procedure TFHPDir.DropFileTarget1Drop(Sender: TObject; ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
var
  i: integer;
begin
  ShowBusy(true);   // wgg
  application.ProcessMessages;
  try
    if not ListView1.Enabled then exit;
    XModemServer.changeDirectory(currentDir);
    with DropFileTarget1 do
      for i := 0 to files.count-1 do
        if not XModemServer.put(ExtractFileName(Files[i]), Files[i]) then exit;
  finally
  ShowBusy(false);   // wgg
  end;
  Timer1.Enabled:= true;
end;

procedure TFHPDir.DropFileTarget2Drop(Sender: TObject; ShiftState: TShiftState;
                    Point: TPoint; var Effect: Integer);
var
  i: integer;
  n: TTreeNode;
begin
  ShowBusy(true);   // wgg
  application.ProcessMessages;
  try
    if not TreeView1.Enabled then exit;
    n:= TreeView1.GetNodeAt(Point.x, Point.y);
    if n=nil then exit;
    TreeView1.Selected:= n;
    XModemServer.changeDirectory(currentDir);
    with DropFileTarget1 do
      for i := 0 to files.count-1 do
        if not XModemServer.put(ExtractFileName(Files[i]), Files[i]) then exit;
  finally
  ShowBusy(false);   // wgg
  end;
  Timer1.Enabled:= true;
  end;
  
procedure TFHPDir.ToolButton6Click(Sender: TObject);
begin
  XModemServer.Kill;
end;

procedure TFHPDir.ListView1Edited(Sender: TObject; Item: TListItem; var S: String);
begin
  XModemServer.Rename(Item.Caption, s, (Item.ImageIndex = 0) Or (Item.ImageIndex = 11));  // wgg
  Timer1.Enabled:= true;
end;

procedure TFHPDir.ListView1DblClick(Sender: TObject);
var
  t: TListItem;
begin
  exit;
  ShowBusy(true);   // wgg
  try
    if CPoint.x<>-1 then
    begin
      t:= ListView1.GetItemAt(cPoint.x, cPoint.y);
      if t<>nil then
        XModemServer.ExecFile(t.Caption);
    end;
  finally
  ShowBusy(false);   // wgg
  end;
end;

procedure TFHPDir.mnuCommHelpClick(Sender: TObject);
begin
  ContextHelp((Sender as TMenuItem).HelpContext);            // wgg
end;

procedure TFHPDir.mnuContentsHelpClick(Sender: TObject);                    // wgg
begin
 { Application.HelpCommand(HELP_FINDER, 0);   }                        // wgg - old style help command
  HtmlHelp(0, nil, HH_CLOSE_ALL, 0);                                   // wgg - HTLM help commands
  HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile), HH_DISPLAY_TOC, 0);
end;

// wgg for Html help API - display popup text
procedure TFHPDir.TopicHelp(topic: string);
begin
HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile), HH_DISPLAY_TOPIC,
                    DWORD(PChar(topic)));
end;

// wgg we call this to display HTML context help
procedure TFHPDir.ContextHelp(id: integer);
begin
  HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile), HH_HELP_CONTEXT, id);
end;
// wgg Schema for Control HelpContext IDs
// 0, 1	Used when no help topic is defined.  1 is a system default page.
//
// Remaining IDs are a 7 digit number FFFnnnn where
//
// FFF	form number
//      12 = Connectivity
//
// nnnn:	topic for the form:
// 0000-4999 Text help for pop-ups.  These are defined in cshelp.txt
// 5000-9999 Context help that goes to a topic page, mapped in cshelp.ali and cshelp.h
//
// CSHelp.ali:  List symbolic ID and the path to the html
// CSHelp.h:    Lists symbolic id and the number from the program
// CSHelp.txt:  Lists .topic nnnn, where nnn is used in the program, text follows immediately
//
// wgg form's BorderIcons\biHelp must be true for pop-up help
procedure ShowHelp(Pt: TPoint; ContextId: Integer);
var
  Popup: THHPopup;
begin
  if (ContextID Mod 10000) >= 5000 then FHPdir.ContextHelp(ContextID)     // wgg show in the help window
  else
  begin
    FillChar(Popup, SizeOf(Popup), 0);
    Popup.cbStruct := SizeOf(Popup);
    Popup.hinst := 0;
    Popup.idString := ContextId;
    Popup.pszText := nil;
    Popup.pt := Pt;
    Popup.clrForeGround := TColorRef(-1);
    Popup.clrBackground := TColorRef(-1);
    Popup.rcMargins := Rect(-1, -1, -1, -1);
    Popup.pszFont := '';
    if (ContextId <= 1) then                    // wgg 1 is a default error msg
      if Screen.ActiveControl.Hint <> '' then   // show hint if we have one
      begin
        Popup.pszText := PChar(Screen.ActiveControl.Hint);
        Popup.idString := 0;
        HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile+'::/'+PopupFileName),
               HH_DISPLAY_TEXT_POPUP, DWORD(@Popup));
      end else                                  // else nothing happens
    else
      HtmlHelp(0, PChar(ApplicationPath+'\'+Application.HelpFile+'::/'+PopupFileName),
               HH_DISPLAY_TEXT_POPUP, DWORD(@Popup));
  end;
end;

function TFHPDir.ApplicationOnHelp(Command: Word; Data: Integer; var CallHelp: Boolean): Boolean;
const
  Pos: TPoint = (X:0; Y:0);              // the mouse pos
begin
  CallHelp := False;                     // Instruct Delphi not to call WinHelp
  Result := True;
  case Command of
    HELP_SETPOPUP_POS: Pos := SmallPointToPoint(TSmallPoint(Data));  // Remember mouse position
    // This is our chance to show help. The Data parameter is the helpcontext
    // property of the control beneath the mouse cursor when help was requested,
    // either through F1 or What's This Help.
    HELP_CONTEXTPOPUP: ShowHelp(Pos, Data);
    else Result := False;
  end;
end;

// wgg set the calculator type string
procedure TFHPDir.SetCalcTypeString(s: string);
begin
  FCalcTypeString:= s;
  TreeView1.Items[0].text:= 'HOME ('+'HP-'+GetCalcTypeString+')';  // wgg, s could be ''
end;

// wgg Some operations depend on being a 49 server
function TFHPDir.IsCalc49: boolean;
begin
  result:= GetCalcTypeString = HP49String;
end;

// wgg My XModem Server returns a calculator string, else its a 49
function TFHPDir.GetCalcTypeString: string;
begin
  if CalcTypeString<>'' then          // wgg changed this whole thing
    result:= CalcTypeString
  else
    result:= '?';
end;

// wgg common download file using built-in function XRECV
procedure TFHPDir.DoDownloadFile(f: TFileName; prompt: integer);
var
  b: boolean;
begin
  if XModemServer.SetDowncom(ComboBox1.Text) then
  begin
    Connected:= XModemServer.connected;
    ShowBusy(true);
    application.ProcessMessages;
    b:= XModemServer.DownLoad(f);
    Connected:= false;
    ShowBusy(false);
    if b then FDownLd.Execute(prompt);
  end;
end;

// wgg download a copy of the server using built-in function XRECV
procedure TFHPDir.mnuDownLoadServerClick(Sender: TObject);
begin
  if FDownLd.Execute(1) then DoDownLoadFile(ApplicationPath+'\XSrvr.hp', 2);
end;

// wgg download a file using built-in function XRECV
procedure TFHPDir.mnuDownloadFileClick(Sender: TObject);
begin
  OpenDialog1.Filter:= 'HP Files (*.hp)|*.HP|All Files (*.*)|*.*';
  OpenDialog1.Title:='Download File to Calculator';
  if OpenDialog1.execute then
    if FDownLd.Execute(4) then
      if XModemServer.SetDowncom(ComboBox1.Text) then DoDownLoadFile(OpenDialog1.FileName, 5)
end;

// wgg download project using built-in function XRECV
procedure TFHPDir.mnuDownloadProjectClick(Sender: TObject);
begin
  if FDownLd.Execute(4) then
    if XModemServer.SetDowncom(ComboBox1.Text) then DoDownLoadFile(FProjectFile, 5)
end;

//wgg send the project file via XModem Server
procedure TFHPDir.mnuPutProjectClick(Sender: TObject);
begin
  if Not connected then SetComPort;
  ShowBusy(true);   // wgg
  FLoadToReal(Server);                         // FProject sets this callback
  // Setconnected(false);                     // warmstart kills the server
  XModemServer.Kill;   // if a lib and a 48, it is already dead due to warmstart!
  ShowBusy(false);
end;

// wgg upload a file using built-in function XSEND
procedure TFHPDir.mnuUploadFileClick(Sender: TObject);
begin
  SaveDialog1.Filter:= 'HP Files (*.hp)|*.HP|All Files (*.*)|*.*';
  SaveDialog1.Title:='Upload File to PC';
  if SaveDialog1.execute then
    if FDownLd.Execute(6) then
      if XModemServer.SetDowncom(ComboBox1.Text) then
      begin
        Connected:= XModemServer.connected;
        ShowBusy(true);
        application.ProcessMessages;
        XModemServer.UpLoad(SaveDialog1.FileName);
        if XModemServer.FileText<> '' then
          if Not Fixfile(XModemServer.FileText) then          // wgg never fails
            Application.MessageBox(pchar(SaveDialog1.FileName+#13#10
                                          +'Cannot decompile this file.'#13#10
                                          +'Length has been left with padding.'#13#10
                                          +'File may still be ok.'),
                                   pchar('Decompile Error'))
          else   StringToFile(XModemServer.FileText, SaveDialog1.FileName);
        Connected:= false;
        ShowBusy(false);
      end;
end;

// wgg Capture a screen for calculator using its screen printing
procedure TFHPDir.mnuCaptureScreenClick(Sender: TObject);
var
  s: string;
begin
  if connected then XModemServer.kill;
  if XModemServer.SetDowncom(ComboBox1.Text) then
    if FDownLd.Execute(3) then
    begin
      ShowBusy(true);
      Application.ProcessMessages;
      s:= XModemServer.ScreenCapture;
      Connected:= false;
      ShowBusy(false);
      if s <> '' then FCapture.Screen(s);
    end;
end;

procedure TFHPDir.FormShow(Sender: TObject);
begin
  FDownLd.CenterOnMe(self);
  FCmStatus.CenterOnMe(self);
  URLForm.CenterOnMe(self);
end;

end.
