{ File MandelF.pas created by Cyrille de brebisson,
This is the mandel component.
 copyright Cyrille de brebisson 1999}

{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit MandelF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Mandel, dib;

const nbc1=10;
      nbc2=10;
      r1=60;
      r2=20;

type
  TFMandel = class(TForm)
    MandelPannel1: TMandelPannel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormPaint(Sender: TObject);
  private
    dib1: TDib8;
    mat: TTransMat;
    procedure work2(sender: tobject; var done: boolean);
  public
    { Public declarations }
  end;

var
  FMandel: TFMandel;

implementation

{$R *.DFM}

procedure DrawProc(const f:tface3d);
var c1,c2,c3:byte;
Begin
  if f.p1^.nzr>=0 then
    c1:=round(f.p1^.nzr*120)+10
  else
    c1:=10;
  if f.p2^.nzr>=0 then
    c2:=round(f.p2^.nzr*120)+10
  else
    c2:=10;
  if f.p3^.nzr>=0 then
    c3:=round(f.p3^.nzr*120)+10
  else
    c3:=10;
  FMandel.dib1.Gourau(f.p1^,f.p2^,f.p3^,c1,c2,c3);
End;

var
  torep : array [0..nbc1*nbc2-1] of tpoints3d;
  toref : array [0..2*nbc1*nbc2-1] of TFace3d;

var
  a1,a2,a3:extended;

procedure TFMandel.work2(sender: tobject; var done: boolean);
begin
  done:= false;
  with mat do
  begin
    identity;                    // compute the rotation matrix
    rotate(a1,a2,a3);
    scale(1,1,1);
    translate(224 div 2,224 div 2,0);
    multiplyPointsPos(torep);   // do the rotations of the points and normals
    multiplyPointsNorm(torep);
    multiplyFaceNorm(toref);
  end;
  CalcZ(toref);                 // compute the Z of the face
  dib1.clear(138);              // clear the grob
  ExecFaceZ(toref,drawProc);    // draw the faces from far to front
  dib1.DrawToDC(canvas.handle,328,8); // draw on the DC
  a1:=a1+0.02;                  // next angle
  a2:=a2+0.03;
  a3:=a3+0.04;
end;

procedure TFMandel.FormShow(Sender: TObject);
var i,j:integer;
begin
  a1:=0;
  for i:=0 to nbc1-1 do
  begin
    a2:=0;
    for j:=0 to nbc2-1 do
    begin
      torep[i*nbc1+j]:=Point3d6f(r1*cos(a1)+r2*cos(a2)*cos(a1), r2*sin(a2), r1*sin(a1)+r2*cos(a2)*sin(a1),
                                 cos(a2)*cos(a1),sin(a2),cos(a2)*sin(a1));
      a2:=a2+(pi*2)/nbc2;
    end;
    a1:=a1+(pi*2)/nbc1;
  end;
  for i:=0 to nbc1-1 do
    for j:=0 to nbc2-1 do
    Begin
      toref[2*(i*nbc1+j)]:=Face3dcn(@(torep[i*nbc1+j]),@(torep[((i+1) mod nbc1)*nbc1+j]),@(torep[i*nbc1+((j+1) mod nbc2)]));
      toref[2*(i*nbc1+j)+1]:=Face3dcn(@(torep[((i+1) mod nbc1)*nbc1+j]),@(torep[((i+1) mod nbc1) *nbc1+ ((j+1) mod nbc2)]),@(torep[i*nbc1+((j+1) mod nbc2)]));
    End;
  a1:=0;
  a2:=0;
  a3:=0;
  application.OnIdle:= work2;
end;

procedure TFMandel.FormCreate(Sender: TObject);
var
  j: integer;
begin
  FMandel:= self;
  dib1:= TDib8.Create;
  dib1.Width:= 224;
  dib1.Height:= 224;
    for j:=10 to 137 do
      dib1.colors[j]:=((j-10)*2) shl 16;
  dib1.colors[138]:=$ffffff;
  dib1.AssociationPal(canvas.handle);
  mat:= TTransMat.Create;
end;

procedure TFMandel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.OnIdle:= nil;
end;

procedure TFMandel.FormPaint(Sender: TObject);
begin
  dib1.DrawToDC(canvas.handle,328,8); // draw on the DC
end;

end.
