{ file Properties.pas, created on 7/11/2000 by Cyrille de Brbisson

 Just display information on a list of selected files

 Copyright (c) Hewlett-Packard Australia Ltd. 2000
 All rights reserved.  Reproduction, adaptation or translation
 without prior written permission is prohibited, except as
 allowed under the copyright laws.}

 unit Properties;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFProperty = class(TForm)
    Label1: TLabel;
    ListBox1: TListBox;
    Label2: TLabel;
    Size: TLabel;
    Label3: TLabel;
    Time: TLabel;
    Button1: TButton;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Execute(Objects: string; Size: integer; time: integer);
    procedure CenterOnMe(Sender: TForm);   // wgg form to use for centering
  end;

var
  FProperty: TFProperty;
  HPDirForm: TForm;

implementation

uses HPDir;

{$R *.DFM}

{ TForm2 }

procedure TFProperty.CenterOnMe(Sender: TForm);   // form to use for centering
begin
  HPDirForm:= Sender;    // remember so we can center and then restore
end;

procedure TFProperty.Execute(Objects: string; Size: integer; time: integer);
begin
  ListBox1.Items.text:= Objects;
  if Size > 1024 then
    self.Size.Caption:= inttostr(Size div 1024)+' KB'
  else
    self.Size.Caption:= inttostr(Size)+' B';
  Time:= Time;
  if Time<(2) then Time:= 2;
  Self.Time.Caption:= inttostr(Time div 60)+'min : '+inttostr(Time-(Time div 60 * 60))+'s';
  ShowModal;
end;

procedure TFProperty.FormShow(Sender: TObject);
begin
  if HPDirForm=Nil then exit;
  Left:= (HPDirForm.Width-Width) div 2 + HPDirForm.Left;
  Top:= (HPDirForm.Height-Height) div 2 + HPDirForm.Top;
end;

end.
