{ file ScreenCapt.pas, created on 7/11/2000 by Cyrille de Brbisson

 This unit is the screen capture dialog box.
 it displays the captured screen with the appropriate borders
 and allows to copy it in the clipboard. 

 Copyright (c) Hewlett-Packard Australia Ltd. 2000
 All rights reserved.  Reproduction, adaptation or translation
 without prior written permission is prohibited, except as
 allowed under the copyright laws.}

// Items marked wgg are copyright 2002, William G. Graves

unit ScreenCapt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ClipBrd, Spin, Menus, utils, windowsPosSave;

type
  TFCapture = class(TForm)
    Image1: TImage;
    MainMenu1: TMainMenu;
    mnuCopy: TMenuItem;
    mnuClose: TMenuItem;
    N1: TMenuItem;
    WindowPosSave1: TWindowPosSave;
    procedure FormCreate(Sender: TObject);
    procedure mnuCloseClick(Sender: TObject);
    procedure mnuCopyClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    BorderWidth, BorderSpace: integer;
  public
    Procedure Screen(s: string);
    Procedure Refresh;
  end;

var
  FCapture: TFCapture;
implementation

uses HPDir;

{$R *.DFM}

{ TFCapture }

// wgg now takes a string from the HP
procedure TFCapture.Screen(s: string);
var
  sx, sy: integer;
  iBorderWidth: integer;
  iBorderSpace: integer;
  w, h, x, y: integer;
begin
  iBorderWidth:= BorderWidth;
  iBorderSpace:= BorderSpace;

  w:= 131;
  h:= 64;
  sx:= w+2*iborderSpace+2*iBorderWidth;
  sy:= h+2*iborderSpace+2*iBorderWidth;

  Image1.Width:= sx;               // control dimensions
  Image1.Height:= sy;
  Image1.picture.Bitmap.width:= sx;
  Image1.picture.Bitmap.height:= sy;
    
  with Image1.picture.bitmap.canvas do
  begin
    if BorderWidth>0 then pen.color:= clBlack
    else pen.color:= clWhite;
    pen.Width:= BorderWidth;
    brush.color:= clWhite;
    Rectangle(1, 1, sx+1, sy+1);
  end;

  ClientWidth:= 2*sx;
  ClientHeight:= 2*sy;
  if s[1]=#$1B then             // wgg added this for HP-48
    with Image1.picture.bitmap.canvas do
    for y:= 0 to h-1 do
      for x:=0 to w-1 do
        if (ord(s[3+(y div 8)*135 + x]) And (1 shl (y mod 8)))=0 then
          pixels[x+iborderSpace+iBorderWidth, y+iborderSpace+iBorderWidth]:= clWhite
        else
          pixels[x+iborderSpace+iBorderWidth, y+iborderSpace+iBorderWidth]:= clBlack
  else                         // wgg for HP-49
    with Image1.picture.bitmap.canvas do
    for y:= 0 to h-1 do
      for x:=0 to w-1 do
        if (ord(s[3+y*17+ (x div 8)]) And (1 shl (x mod 8)))=0 then
          pixels[x+iborderSpace+iBorderWidth, y+iborderSpace+iBorderWidth]:= clWhite
        else
          pixels[x+iborderSpace+iBorderWidth, y+iborderSpace+iBorderWidth]:= clBlack;

  Refresh;
end;

Procedure TFCapture.Refresh;
begin
    Clipboard.Assign(Image1.Picture);
    Show;
end;

procedure TFCapture.mnuCopyClick(Sender: TObject);
begin
  Clipboard.Assign(Image1.Picture);
end;

procedure TFCapture.FormCreate(Sender: TObject);
begin
  BorderWidth:= 0;        // size of a black border
  BorderSpace:= 1;        // size of a white frame area must be >= BorderWidth
  WindowPosSave1.ReadPos;
end;

procedure TFCapture.mnuCloseClick(Sender: TObject);
begin
  close;
end;

procedure TFCapture.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Visible:= false;              // wgg so WindowPossave.ReadPos won't show it
  WindowPosSave1.SavePos;
end;

end.
